-- Module add by bits&bytes on 20/Sep/2013
------------------------------------------

--	This will be the module table
local M			= {}

--	This is the callback that is called once a GUI event is triggered (button click, ...)
local function GUICallback( mode, str )
	
	--	Extract args
	local args	= unserialize( str )
	
	--	Clicked the Ok button
	if mode == "apply" then
		if tonumber( args.Parameter_kbdInRate) ~= nil then 
			Par_kbdInRate = tonumber( args.Parameter_kbdInRate ) 
		end
		if tonumber( args.Parameter_kbdOutRate ) ~= nil then 
			Par_kbdOutRate = tonumber( args.Parameter_kbdOutRate ) 
		end
		if tonumber( args.Parameter_kbdAutoCenterRate ) ~= nil then 
			Par_kbdAutoCenterRate = tonumber( args.Parameter_kbdAutoCenterRate ) 
		end
 		input.UpdateSteeringParameters()		
	end
end

--	This is the function that displays the GUI
--	It should be included in the public interface so that
--	any external component can call it (like a key bind in keyboard mappings)
local function showGUI()
		-- print("GUI wordt aangemaakt")
		-- print("Par_kbdInRate = " .. tostring(Par_kbdInRate))
	local g		= [[beamngguiconfig 1
callback activeVehicle SteeringParametersGUI.GUICallback
title Steering Parameters

container
	type = verticalStack
	name = root
	
control
	type = text
	name = Parameter_kbdInRate
	description = Steering In Rate (original was ]] .. tostring(Par_kbdInRate) .. [[)
	
control
	type = text
	name = Parameter_kbdOutRate
	description = Steering Out Rate (original was ]] .. tostring(Par_kbdOutRate) .. [[)
	
control
	type = text
	name = Parameter_kbdAutoCenterRate
	description = Steering Auto Center Rate (original was ]] .. tostring(Par_kbdAutoCenterRate) .. [[)
	
control
	type = doneButton
	icon = tools/gui/images/iconAccept.png
	description = Ok
	
]]
	gameEngine:showGUI( g )
end

--	Public interface
--	Defines what is visible to the outside world
M.printText		= printText
M.showGUI		= showGUI
M.GUICallback	= GUICallback

--	Return the module table
return M